#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
#include <stack>
#include <queue>
#include <cmath>
#include <map>
#include <set>
#include <list>
#define MAXSZ 32
#define MAXSUM 256
using namespace std;
typedef long long ll;
ll dp[MAXSZ][MAXSUM][2];
ll dp1[MAXSZ][MAXSUM];
ll n, m;
ll sz(ll num)
{
    ll ans = 0;
    while (num)
    {
        ans++;
        num /= 10;
    }
    return ans;
}
ll sum_dig(ll num)
{
    ll ans = 0;
    while (num)
    {
        ans += num % 10;
        num /= 10;
    }
    return ans;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    for (int i = 1; i <= 9; i++)
        dp[1][i][1] = 1;
        dp[1][0][0] = 1;
    for (int i = 2; i <= n+1; i++)
        for (int j = 0; j <= (n+1) * 9; j++)
            {
                for (int k = 1; k <= min(9, j); k++)
                    dp[i][j][1] += dp[i-1][j-k][1] + dp[i-1][j-k][0];
                dp[i][j][0] = dp[i-1][j][1] + dp[i-1][j][0];
            }
    for (int i = n+1; i >= 1; i--)
        for (int j = 1; j <= 9 * (n+1); j++)
        dp1[i][j] = dp1[i+1][j] + dp1[i][j-1] + dp[i][j][1];

    for (int i = 1; i <= m; i++)
    {
        ll curr_num;
        cin >> curr_num;
        cout << dp1[sz(curr_num)+1][sum_dig(curr_num)-1] << endl;
    }
}
