#include<iostream>
#include<map>
using namespace std;
int n, m;

long long digSum;
int digits;
int d(long long k)
{
    int r=0;
    while(k)
    {
        digSum+=k%10;
        k/=10;
        r++;
    }

    return r;
}

long long answer;
void findNumbers(int dig, long long sum)
{
    if(sum==digSum)
    {
        if(dig>digits && dig<=n) answer++;

        if(dig<n) findNumbers(dig+1, sum);
    }
    else
    {
        int p=9;
        if(digSum-sum<9) p=digSum-sum;

        if(dig<n-1)
            for(int i=0;i<=p;i++)
            {
                findNumbers(dig+1, sum+i);
            }
    }
}

int main()
{
    long long k;
    cin>>n>>m;

    map<int, long long> done;
    bool space=false;

    for(int i=0; i<m; i++)
    {
        cin>>k;

        if(k==1)
        {
            if(space)
                cout<<" 0";
            else
            {
                space=true;
                cout<<0;
            }
            continue;
        }

        digSum=0;
        digits=d(k);

        if(done.count(digits))
        {
            if(space)
                cout<<" "<<done[digits];
            else
            {
                space=true;
                cout<<done[digits];
            }
            continue;
        }

        answer=0;
        if(digSum>1) answer++;
        for(int j=1; j<=9; j++)
        {
            findNumbers(1, j);
        }

        done[digits]=answer;

        if(space)
            cout<<" "<<answer;
        else
        {
            space=true;
            cout<<answer;
        }
        continue;
    }

    return 0;
}
